unit SocketObj0;

interface

uses
  ComObj, ActiveX, AspTlb, SocketObject_TLB, StdVcl, SysUtils, Classes,idFTPCommon, idFTP;

type
  Tftp = class(TASPObject, Iftp)
  protected
    FErrorMessage : WideString;
    FIdFTP        : TidFtp;

    procedure OnEndPage; safecall;
    procedure OnStartPage(const AScriptingContext: IUnknown); safecall;
    procedure Download(const RemoteFilename, LocalFilename: WideString);   safecall;
    procedure Set_Host(const Value: WideString); safecall;
    procedure Set_Password(const Value: WideString); safecall;
    procedure Set_UserName(const Value: WideString); safecall;
    procedure Upload(const LocalFilename: WideString; const RemoteFilename: WideString); safecall;
    procedure Delete(const Filename: WideString); safecall;
    procedure ChangeDir(const Directory: WideString); safecall;
    procedure Connect; safecall;
    procedure Disconnect; safecall;
    function Get_DirectoryList: WideString; safecall;
    function Get_ErrorMessage: WideString; safecall;
    procedure MakeDir(const Value: WideString); safecall;
    function Get_CurrentDir: WideString; safecall;
    procedure ProxyHost(const Value: WideString); safecall;
    procedure ProxyPort(Value: Integer); safecall;
    procedure ProxyType(Value: Integer); safecall;
  end;

implementation

uses ComServ;

procedure Tftp.OnEndPage;
begin
  FidFTP.Free;;
  inherited OnEndPage;
end;

procedure Tftp.OnStartPage(const AScriptingContext: IUnknown);
begin
  FidFTP := TidFtp.Create(nil);
  inherited OnStartPage(AScriptingContext);
end;

procedure Tftp.Download(const RemoteFilename, LocalFilename: WideString);
begin
   FErrorMessage := '';
   Try
      FidFTP.TransferType := ftBinary;
      FidFTP.Get(RemoteFilename,LocalFilename);
   Except
   on e:Exception do Begin
      FErrorMessage := e.Message;
      End;
   End;
end;

procedure Tftp.Set_Host(const Value: WideString);
begin
  FidFTP.Host := Value;
end;

procedure Tftp.Set_Password(const Value: WideString);
begin
  FidFTP.Password := Value;
end;

procedure Tftp.Set_UserName(const Value: WideString);
begin
  FidFTP.Username := Value;
end;

procedure Tftp.Upload(const LocalFilename: WideString; const RemoteFilename: WideString);
begin
  FErrorMessage := '';
  Try
     FidFTP.TransferType := ftBinary;
     FidFTP.Put(LocalFilename,RemoteFilename);
  Except
  on e:Exception do Begin
     FErrorMessage := e.Message;
     End;
  End;
end;

procedure Tftp.Delete(const Filename: WideString);
begin
  FErrorMessage := '';
  Try
     FidFTP.Delete(FileName);
  Except
  on e:Exception do Begin
     FErrorMessage := e.Message;
     End;
  End;
end;

procedure Tftp.ChangeDir(const Directory: WideString);
begin
  FErrorMessage := '';
  Try
     FidFTP.ChangeDir(Directory);
  Except
  on e:Exception do Begin
     FErrorMessage := e.Message;
     End;
  End;
end;

procedure Tftp.Connect;
begin
  FErrorMessage := '';
  if FidFTP.Connected then Begin
    try
      FidFTP.Abort;
      FidFTP.Quit;
    Except
    End;
  End;
  Try
     FidFTP.Connect;
  Except
  on e:Exception do Begin
     FErrorMessage := e.Message;
     End;
  End;
end;

procedure Tftp.Disconnect;
begin
  FErrorMessage := '';
  Try
     if FidFTP.Connected then FidFTP.Disconnect;
  Except
  on e:Exception do Begin
     FErrorMessage := e.Message;
     End;
  End;
end;

function Tftp.Get_DirectoryList: WideString;
Var LS: TStringList;
begin
  FErrorMessage := '';
  Try
    LS := TStringList.Create;
    try
      FidFTP.TransferType := ftASCII;
      FidFTP.List(LS);
      Result := LS.Text;
    Finally
      LS.Free;
    End;
  Except
  on e:Exception do Begin
     FErrorMessage := e.Message;
     End;
  End;
end;

function Tftp.Get_ErrorMessage: WideString;
begin
   Result := FErrorMessage;
end;

procedure Tftp.MakeDir(const Value: WideString);
begin
  FErrorMessage := '';
  Try
     FidFTP.MakeDir(Value);
  Except
  on e:Exception do Begin
     FErrorMessage := e.Message;
     End;
  End;
end;

function Tftp.Get_CurrentDir: WideString;
begin
  FErrorMessage := '';
  Try
     Result := FidFTP.RetrieveCurrentDir;
  Except
  on e:Exception do Begin
     FErrorMessage := e.Message;
     End;
  End;
end;

procedure Tftp.ProxyHost(const Value: WideString);
begin
  FErrorMessage := '';
  Try
     FidFTP.ProxySettings.Host := Value;
  Except
  on e:Exception do Begin
     FErrorMessage := e.Message;
     End;
  End;
end;

procedure Tftp.ProxyPort(Value: Integer);
begin
  FErrorMessage := '';
  Try
     FidFTP.ProxySettings.Port := Value;
  Except
  on e:Exception do Begin
     FErrorMessage := e.Message;
     End;
  End;
end;

procedure Tftp.ProxyType(Value: Integer);
begin
  FErrorMessage := '';
  Try
     FidFTP.ProxySettings.ProxyType := TIdFtpProxyType(Value);
  Except
  on e:Exception do Begin
     FErrorMessage := e.Message;
     End;
  End;
end;

initialization
  TAutoObjectFactory.Create(ComServer, Tftp, Class_ftp, ciMultiInstance, tmApartment);
end.
